# Copyright (c) 2012 Riverbank Computing Limited.
#
# This file is part of dip.
#
# This file may be used under the terms of the GNU General Public License
# v2 or v3 as published by the Free Software Foundation which can be found in
# the files LICENSE-GPL2.txt and LICENSE-GPL3.txt included in this package.
# In addition, as a special exception, Riverbank gives you certain additional
# rights.  These rights are described in the Riverbank GPL Exception, which
# can be found in the file GPL-Exception.txt in this package.
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.


from ..model import adapt, Adapter, Interface, Str


class IAreaHints(Interface):
    """ The IAreaHints interface defines the metadata that an object may
    provide for an :term:`area`.
    """

    # The identifier of the area where the view should be placed.  An empty
    # string corresponds to the shell-specific default area.
    area = Str()


@adapt(object, to=IAreaHints)
class objectIAreaHintsAdapter(Adapter):
    """ An adapter to implement IAreaHints for any object. """
