# Copyright (c) 2011 Riverbank Computing Limited.
#
# This file is part of dip.
#
# This file may be used under the terms of the GNU General Public License
# v2 or v3 as published by the Free Software Foundation which can be found in
# the files LICENSE-GPL2.txt and LICENSE-GPL3.txt included in this package.
# In addition, as a special exception, Riverbank gives you certain additional
# rights.  These rights are described in the Riverbank GPL Exception, which
# can be found in the file GPL-Exception.txt in this package.
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.


from PyQt4.QtGui import QLabel

from ....model import adapt
from ....ui import ILabel, IMessageArea

from ..editor_widget_adapter import EditorWidgetAdapter
from ..widget_adapter import WidgetAdapter


@adapt(QLabel, to=ILabel)
class QLabelILabelAdapter(EditorWidgetAdapter):
    """ An adapter to implement ILabel for a QLabel. """

    @ILabel.value.getter
    def value(self):
        """ Invoked to get for the editor's value. """

        return self.adaptee.text()

    @ILabel.value.setter
    def value(self, value):
        """ Invoked to set for the editor's value. """

        self.adaptee.setText(value)


@adapt(QLabel, to=IMessageArea)
class QLabelIMessageAreaAdapter(WidgetAdapter):
    """ An adapter to implement IMessageArea for a QLabel. """

    @IMessageArea.text.setter
    def text(self, value):
        """ The setter for the message area's text. """

        self.adaptee.setText(value)
