# Copyright (c) 2012 Riverbank Computing Limited.
#
# This file is part of dip.
#
# This file may be used under the terms of the GNU General Public License
# v2 or v3 as published by the Free Software Foundation which can be found in
# the files LICENSE-GPL2.txt and LICENSE-GPL3.txt included in this package.
# In addition, as a special exception, Riverbank gives you certain additional
# rights.  These rights are described in the Riverbank GPL Exception, which
# can be found in the file GPL-Exception.txt in this package.
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.


from ..model import Instance, Interface

from .i_view import IView


class IApplication(Interface):
    """ The IApplication interface defines the API to be implemented by an
    application created by :class:`~dip.ui.Application`.
    """

    # The active view (i.e. the one with the focus).
    active_view = Instance(IView)

    def execute(self):
        """ Execute the application, i.e. enter its event loop.  It will return
        when the event loop terminates.

        :return:
            An integer exit code.
        """

    def quit(self):
        """ Quit the application, i.e. force its event loop to terminate. """
