# Copyright (c) 2011 Riverbank Computing Limited.
#
# This file is part of dip.
#
# This file may be used under the terms of the GNU General Public License
# v2 or v3 as published by the Free Software Foundation which can be found in
# the files LICENSE-GPL2.txt and LICENSE-GPL3.txt included in this package.
# In addition, as a special exception, Riverbank gives you certain additional
# rights.  These rights are described in the Riverbank GPL Exception, which
# can be found in the file GPL-Exception.txt in this package.
#
# This file is provided AS IS with NO WARRANTY OF ANY KIND, INCLUDING THE
# WARRANTY OF DESIGN, MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.


from .i_message_area import IMessageArea
from .view_factory import ViewFactory


class MessageArea(ViewFactory):
    """ The MessageArea class is a factory for a message area, which will be an
    implementation of, or something that be adapted to,
    :class:`~dip.ui.IMessageArea` to be used by a controller to display
    messages to the user.
    """

    # The specific interface implemented by the view.
    view_interface = IMessageArea

    def bind_view(self, view, controller):
        """ Reimplemented to add the message area view to a controller.

        :param view:
            is the view.
        :param controller:
            is the controller.
        """

        super().bind_view(view, controller)

        controller.message_areas.append(view)
