# Copyright (c) 2010 Riverbank Computing Limited.


try:
    import unittest2 as unittest
except ImportError:
    import unittest

from PyQt4.QtCore import QObject

from dip.model import Model


class TestModel(unittest.TestCase):
    """ This tests the Model class. """

    def test_base_class(self):
        """ Instantiate Model. """

        Model()

    def test_mixin_class_first(self):
        """ Use Model as a mixin with PyQt (Model first). """

        class Klass(Model, QObject): pass

        k = Klass()

        self.assertEqual(k.metaObject().className(), 'Klass')

    def test_mixin_class_last(self):
        """ Use Model as a mixin with PyQt (Model last). """

        class Klass(QObject, Model): pass

        k = Klass()

        self.assertEqual(k.metaObject().className(), 'Klass')


if __name__ == '__main__':
    unittest.main()
